<script lang="ts">
  import Tag from '$lib/components/Tag.svelte';
  import Item from '$lib/components/Items/Item.svelte';
  import EditSvg from '$lib/components/svg/EditSvg.svelte';
  import ViewSvg from '$lib/components/svg/ViewSvg.svelte';
  import DeleteSvg from '$lib/components/svg/DeleteSvg.svelte';
  import { axiosInstance } from '$lib/config';
  import { PUBLIC_API_URL } from '$env/static/public';

  export let id: number,
    title: string,
    anons: string,
    author: { lastName: string, firstName: string },
    date: string,
    tags: any[] = [],
    attachment: any;

  const locale = 'ru-RU',
    dateString = new Intl.DateTimeFormat(locale).format(new Date(date));

  async function handleRemove() {
    try {
      const res = await axiosInstance.delete(`/news/${id}`);

      if (res.status === 200) {
        window.location.reload();
      }
    } catch (err) {
      console.error(err);

      alert('Возникла ошибка. Попробуйте повторить действие.');
    }
  }
</script>

<Item>
    <section class="flex gap-6 items-center">
        <img src="{PUBLIC_API_URL}/attachment/{attachment.id}" alt="Файл" class="object-cover aspect-video w-32 rounded-xl">
        <section class="space-y-1">
            <a href="/admin/news/{id}">
                <h2 class="text-2xl font-bold font-serif hover:underline decoration-blue-700">{title}</h2>
            </a>
            <p class="text-neutral-600"><span class="select-none">ID:</span>{id}</p>
        </section>
        <section class="flex flex-wrap gap-4 items-center">
            {#each tags as { name }}
                <Tag noSelect {name}/>
            {/each}
        </section>
    </section>
    <section class="flex gap-6 items-center">
        <section class="text-neutral-600 items-center">
            <address class="not-italic">{author.lastName} {author.firstName}</address>
            <time>{dateString}</time>
        </section>
        <a href="/admin/news/{id}" class="cursor-pointer">
            <EditSvg/>
        </a>
        <a href="/news/{id}" class="cursor-pointer">
            <ViewSvg/>
        </a>
        <button on:click={handleRemove}>
            <DeleteSvg/>
        </button>
    </section>
</Item>